"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MapEntityNameToEntity = MapEntityNameToEntity;
const json_api_nestjs_shared_1 = require("@klerick/json-api-nestjs-shared");
const change_case_commonjs_1 = require("change-case-commonjs");
const constants_1 = require("../constants");
function MapEntityNameToEntity(entities) {
    return {
        provide: constants_1.MAP_ENTITY,
        useValue: entities.reduce((acum, item) => acum.set((0, change_case_commonjs_1.kebabCase)((0, json_api_nestjs_shared_1.getEntityName)(item)), item), new Map()),
    };
}
//# sourceMappingURL=map-entity-name-to-entity.js.map