import { ZodInputQuery, ZodQuery, ZodPost, ZodPatch, ZodPostRelationship, ZodPatchRelationship } from '../zod';
import { FactoryProvider, ValueProvider } from '@nestjs/common';
export declare function ZodInputQuerySchema<E extends object, IdKey extends string = 'id'>(): FactoryProvider<ZodInputQuery<E, IdKey>>;
export declare function ZodQuerySchema<E extends object, IdKey extends string = 'id'>(): FactoryProvider<ZodQuery<E, IdKey>>;
export declare function ZodPostSchema<E extends object, IdKey extends string = 'id'>(): FactoryProvider<ZodPost<E, IdKey>>;
export declare function ZodPatchSchema<E extends object, IdKey extends string = 'id'>(): FactoryProvider<ZodPatch<E, IdKey>>;
export declare const ZodInputPostRelationshipSchema: ValueProvider<ZodPostRelationship>;
export declare const ZodInputPatchRelationshipSchema: ValueProvider<ZodPatchRelationship>;
