import { EntityClass } from '@klerick/json-api-nestjs-shared';
import { EntityParam } from '../../../types';
export declare class EntityParamMapService<E extends object, IdKey extends string = 'id'> {
    private readonly entityParamMap;
    private readonly currentEntity;
    private _entityParaMap;
    getParamMap<T extends object, IdKey extends string = 'id'>(entity: EntityClass<T>): EntityParam<T, IdKey>;
    get entityParaMap(): EntityParam<E, IdKey>;
}
