import { getAll } from './get-all';
import { getOne } from './get-one';
import { deleteOne } from './delete-one';
import { postOne } from './post-one';
import { patchOne } from './patch-one';
import { getRelationship } from './get-relationship';
import { deleteRelationship } from './delete-relationship';
import { postRelationship } from './post-relationship';
import { patchRelationship } from './patch-relationship';
import { OrmService } from '../../types';
export declare const swaggerMethod: {
    readonly getAll: typeof getAll;
    readonly getOne: typeof getOne;
    readonly deleteOne: typeof deleteOne;
    readonly postOne: typeof postOne;
    readonly patchOne: typeof patchOne;
    readonly getRelationship: typeof getRelationship;
    readonly deleteRelationship: typeof deleteRelationship;
    readonly postRelationship: typeof postRelationship;
    readonly patchRelationship: typeof patchRelationship;
};
export type SwaggerMethod<E extends object> = {
    [Key in keyof OrmService<E>]?: (typeof swaggerMethod)[Key];
};
