import { z } from 'zod';
export declare const zodPatchRelationship: z.ZodObject<{
    data: z.ZodUnion<[z.ZodNullable<z.ZodEffects<z.ZodObject<{
        type: z.ZodString;
        id: z.ZodString;
    }, "strict", z.ZodTypeAny, {
        id: string;
        type: string;
    }, {
        id: string;
        type: string;
    }>, {
        id: string;
        type: string;
    }, {
        id: string;
        type: string;
    }>>, z.ZodArray<z.ZodEffects<z.ZodObject<{
        type: z.ZodString;
        id: z.ZodString;
    }, "strict", z.ZodTypeAny, {
        id: string;
        type: string;
    }, {
        id: string;
        type: string;
    }>, {
        id: string;
        type: string;
    }, {
        id: string;
        type: string;
    }>, "many">]>;
}, "strict", z.ZodTypeAny, {
    data: {
        id: string;
        type: string;
    } | {
        id: string;
        type: string;
    }[] | null;
}, {
    data: {
        id: string;
        type: string;
    } | {
        id: string;
        type: string;
    }[] | null;
}>;
export type ZodPatchRelationship = typeof zodPatchRelationship;
export type PatchRelationship = z.infer<ZodPatchRelationship>;
export type PatchRelationshipData = PatchRelationship['data'];
