import { z } from 'zod';
import { EntityParamMapService } from '../../service';
export declare function zodFieldsInputQuery<E extends object, IdKey extends string>(entityParamMapService: EntityParamMapService<E, IdKey>): z.ZodEffects<z.ZodOptional<z.ZodEffects<z.ZodObject<z.objectUtil.extendShape<{
    target: z.ZodEffects<z.ZodOptional<z.ZodString>, string[] | undefined, string | undefined>;
}, { [K in import("../../../../types").UnionToTuple<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>, import("ts-toolbelt/out/Union/Last").Last<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>, [import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>] extends [never] ? true : false>[number] & PropertyKey]: z.ZodEffects<z.ZodOptional<z.ZodString>, string[] | undefined, string | undefined>; }>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<z.objectUtil.extendShape<{
    target: z.ZodEffects<z.ZodOptional<z.ZodString>, string[] | undefined, string | undefined>;
}, { [K in import("../../../../types").UnionToTuple<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>, import("ts-toolbelt/out/Union/Last").Last<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>, [import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>] extends [never] ? true : false>[number] & PropertyKey]: z.ZodEffects<z.ZodOptional<z.ZodString>, string[] | undefined, string | undefined>; }>>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<z.objectUtil.extendShape<{
    target: z.ZodEffects<z.ZodOptional<z.ZodString>, string[] | undefined, string | undefined>;
}, { [K in import("../../../../types").UnionToTuple<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>, import("ts-toolbelt/out/Union/Last").Last<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>, [import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>] extends [never] ? true : false>[number] & PropertyKey]: z.ZodEffects<z.ZodOptional<z.ZodString>, string[] | undefined, string | undefined>; }>>, any>[k]; } : never, z.baseObjectInputType<z.objectUtil.extendShape<{
    target: z.ZodEffects<z.ZodOptional<z.ZodString>, string[] | undefined, string | undefined>;
}, { [K in import("../../../../types").UnionToTuple<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>, import("ts-toolbelt/out/Union/Last").Last<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>, [import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>] extends [never] ? true : false>[number] & PropertyKey]: z.ZodEffects<z.ZodOptional<z.ZodString>, string[] | undefined, string | undefined>; }>> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<z.objectUtil.extendShape<{
    target: z.ZodEffects<z.ZodOptional<z.ZodString>, string[] | undefined, string | undefined>;
}, { [K in import("../../../../types").UnionToTuple<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>, import("ts-toolbelt/out/Union/Last").Last<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>, [import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>] extends [never] ? true : false>[number] & PropertyKey]: z.ZodEffects<z.ZodOptional<z.ZodString>, string[] | undefined, string | undefined>; }>>[k_1]; } : never>, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<z.objectUtil.extendShape<{
    target: z.ZodEffects<z.ZodOptional<z.ZodString>, string[] | undefined, string | undefined>;
}, { [K in import("../../../../types").UnionToTuple<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>, import("ts-toolbelt/out/Union/Last").Last<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>, [import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>] extends [never] ? true : false>[number] & PropertyKey]: z.ZodEffects<z.ZodOptional<z.ZodString>, string[] | undefined, string | undefined>; }>>, any> extends infer T_2 ? { [k in keyof T_2]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<z.objectUtil.extendShape<{
    target: z.ZodEffects<z.ZodOptional<z.ZodString>, string[] | undefined, string | undefined>;
}, { [K in import("../../../../types").UnionToTuple<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>, import("ts-toolbelt/out/Union/Last").Last<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>, [import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>] extends [never] ? true : false>[number] & PropertyKey]: z.ZodEffects<z.ZodOptional<z.ZodString>, string[] | undefined, string | undefined>; }>>, any>[k]; } : never, z.baseObjectInputType<z.objectUtil.extendShape<{
    target: z.ZodEffects<z.ZodOptional<z.ZodString>, string[] | undefined, string | undefined>;
}, { [K in import("../../../../types").UnionToTuple<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>, import("ts-toolbelt/out/Union/Last").Last<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>, [import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>] extends [never] ? true : false>[number] & PropertyKey]: z.ZodEffects<z.ZodOptional<z.ZodString>, string[] | undefined, string | undefined>; }>> extends infer T_3 ? { [k_1 in keyof T_3]: z.baseObjectInputType<z.objectUtil.extendShape<{
    target: z.ZodEffects<z.ZodOptional<z.ZodString>, string[] | undefined, string | undefined>;
}, { [K in import("../../../../types").UnionToTuple<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>, import("ts-toolbelt/out/Union/Last").Last<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>, [import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>] extends [never] ? true : false>[number] & PropertyKey]: z.ZodEffects<z.ZodOptional<z.ZodString>, string[] | undefined, string | undefined>; }>>[k_1]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<z.objectUtil.extendShape<{
    target: z.ZodEffects<z.ZodOptional<z.ZodString>, string[] | undefined, string | undefined>;
}, { [K in import("../../../../types").UnionToTuple<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>, import("ts-toolbelt/out/Union/Last").Last<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>, [import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>] extends [never] ? true : false>[number] & PropertyKey]: z.ZodEffects<z.ZodOptional<z.ZodString>, string[] | undefined, string | undefined>; }>>, any> extends infer T_4 ? { [k in keyof T_4]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<z.objectUtil.extendShape<{
    target: z.ZodEffects<z.ZodOptional<z.ZodString>, string[] | undefined, string | undefined>;
}, { [K in import("../../../../types").UnionToTuple<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>, import("ts-toolbelt/out/Union/Last").Last<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>, [import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>] extends [never] ? true : false>[number] & PropertyKey]: z.ZodEffects<z.ZodOptional<z.ZodString>, string[] | undefined, string | undefined>; }>>, any>[k]; } : never) | null, (z.baseObjectInputType<z.objectUtil.extendShape<{
    target: z.ZodEffects<z.ZodOptional<z.ZodString>, string[] | undefined, string | undefined>;
}, { [K in import("../../../../types").UnionToTuple<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>, import("ts-toolbelt/out/Union/Last").Last<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>, [import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>] extends [never] ? true : false>[number] & PropertyKey]: z.ZodEffects<z.ZodOptional<z.ZodString>, string[] | undefined, string | undefined>; }>> extends infer T_5 ? { [k_1 in keyof T_5]: z.baseObjectInputType<z.objectUtil.extendShape<{
    target: z.ZodEffects<z.ZodOptional<z.ZodString>, string[] | undefined, string | undefined>;
}, { [K in import("../../../../types").UnionToTuple<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>, import("ts-toolbelt/out/Union/Last").Last<import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>>, [import("@klerick/json-api-nestjs-shared").RelationKeys<E, IdKey>] extends [never] ? true : false>[number] & PropertyKey]: z.ZodEffects<z.ZodOptional<z.ZodString>, string[] | undefined, string | undefined>; }>>[k_1]; } : never) | undefined>;
export type ZodFieldsInputQuery<E extends object, IdKey extends string> = z.infer<ReturnType<typeof zodFieldsInputQuery<E, IdKey>>>;
