import { z } from 'zod';
import { EntityParam, TypeForId, RelationProperty, TypeField } from '../../../../types';
import { EntityParamMapService } from '../../service';
declare function getZodResultData<TypeName extends string, Type extends TypeForId, IsNull extends true | false = false, IsPatch extends true | false = false>(typeName: TypeName, primaryType: Type, isNull: IsNull, isPatch: IsPatch): import("./type").ResultSchema<z.ZodEffects<z.ZodObject<{
    data: import("./type").ResultSchema<z.ZodEffects<z.ZodObject<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any>[k]; } : never, z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>[k_1]; } : never>, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any> extends infer T_2 ? { [k in keyof T_2]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any>[k]; } : never, z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }> extends infer T_3 ? { [k_1 in keyof T_3]: z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>[k_1]; } : never>, IsNull, IsPatch>;
}, "strip", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
    data: import("./type").ResultSchema<z.ZodEffects<z.ZodObject<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any> extends infer T_9 ? { [k in keyof T_9]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any>[k]; } : never, z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }> extends infer T_10 ? { [k_1 in keyof T_10]: z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>[k_1]; } : never>, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any> extends infer T_11 ? { [k in keyof T_11]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any>[k]; } : never, z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }> extends infer T_12 ? { [k_1 in keyof T_12]: z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>[k_1]; } : never>, IsNull, IsPatch>;
}>, any> extends infer T_4 ? { [k_2 in keyof T_4]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
    data: import("./type").ResultSchema<z.ZodEffects<z.ZodObject<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any> extends infer T_5 ? { [k in keyof T_5]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any>[k]; } : never, z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }> extends infer T_6 ? { [k_1 in keyof T_6]: z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>[k_1]; } : never>, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any> extends infer T_7 ? { [k in keyof T_7]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any>[k]; } : never, z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }> extends infer T_8 ? { [k_1 in keyof T_8]: z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>[k_1]; } : never>, IsNull, IsPatch>;
}>, any>[k_2]; } : never, z.baseObjectInputType<{
    data: import("./type").ResultSchema<z.ZodEffects<z.ZodObject<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any> extends infer T_18 ? { [k in keyof T_18]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any>[k]; } : never, z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }> extends infer T_19 ? { [k_1 in keyof T_19]: z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>[k_1]; } : never>, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any> extends infer T_20 ? { [k in keyof T_20]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any>[k]; } : never, z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }> extends infer T_21 ? { [k_1 in keyof T_21]: z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>[k_1]; } : never>, IsNull, IsPatch>;
}> extends infer T_13 ? { [k_3 in keyof T_13]: z.baseObjectInputType<{
    data: import("./type").ResultSchema<z.ZodEffects<z.ZodObject<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any> extends infer T_14 ? { [k in keyof T_14]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any>[k]; } : never, z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }> extends infer T_15 ? { [k_1 in keyof T_15]: z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>[k_1]; } : never>, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any> extends infer T_16 ? { [k in keyof T_16]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any>[k]; } : never, z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }> extends infer T_17 ? { [k_1 in keyof T_17]: z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>[k_1]; } : never>, IsNull, IsPatch>;
}>[k_3]; } : never>, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
    data: import("./type").ResultSchema<z.ZodEffects<z.ZodObject<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any> extends infer T_27 ? { [k in keyof T_27]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any>[k]; } : never, z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }> extends infer T_28 ? { [k_1 in keyof T_28]: z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>[k_1]; } : never>, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any> extends infer T_29 ? { [k in keyof T_29]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any>[k]; } : never, z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }> extends infer T_30 ? { [k_1 in keyof T_30]: z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>[k_1]; } : never>, IsNull, IsPatch>;
}>, any> extends infer T_22 ? { [k_2 in keyof T_22]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
    data: import("./type").ResultSchema<z.ZodEffects<z.ZodObject<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any> extends infer T_23 ? { [k in keyof T_23]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any>[k]; } : never, z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }> extends infer T_24 ? { [k_1 in keyof T_24]: z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>[k_1]; } : never>, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any> extends infer T_25 ? { [k in keyof T_25]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any>[k]; } : never, z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }> extends infer T_26 ? { [k_1 in keyof T_26]: z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>[k_1]; } : never>, IsNull, IsPatch>;
}>, any>[k_2]; } : never, z.baseObjectInputType<{
    data: import("./type").ResultSchema<z.ZodEffects<z.ZodObject<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any> extends infer T_36 ? { [k in keyof T_36]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any>[k]; } : never, z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }> extends infer T_37 ? { [k_1 in keyof T_37]: z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>[k_1]; } : never>, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any> extends infer T_38 ? { [k in keyof T_38]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any>[k]; } : never, z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }> extends infer T_39 ? { [k_1 in keyof T_39]: z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>[k_1]; } : never>, IsNull, IsPatch>;
}> extends infer T_31 ? { [k_3 in keyof T_31]: z.baseObjectInputType<{
    data: import("./type").ResultSchema<z.ZodEffects<z.ZodObject<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any> extends infer T_32 ? { [k in keyof T_32]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any>[k]; } : never, z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }> extends infer T_33 ? { [k_1 in keyof T_33]: z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>[k_1]; } : never>, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any> extends infer T_34 ? { [k in keyof T_34]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any>[k]; } : never, z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }> extends infer T_35 ? { [k_1 in keyof T_35]: z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>[k_1]; } : never>, IsNull, IsPatch>;
}>[k_3]; } : never>, IsNull, IsPatch>;
declare function getZodResultDataArray<TypeName extends string, Type extends TypeForId>(typeName: TypeName, primaryType: Type): z.ZodOptional<z.ZodObject<{
    data: z.ZodArray<z.ZodEffects<z.ZodObject<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any>[k]; } : never, z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>[k_1]; } : never>, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any> extends infer T_2 ? { [k in keyof T_2]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any>[k]; } : never, z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }> extends infer T_3 ? { [k_1 in keyof T_3]: z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>[k_1]; } : never>, "many">;
}, "strip", z.ZodTypeAny, {
    data: (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any> extends infer T_4 ? { [k in keyof T_4]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>, any>[k]; } : never)[];
}, {
    data: (z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }> extends infer T_5 ? { [k_1 in keyof T_5]: z.baseObjectInputType<{
        id: z.ZodString;
        type: z.ZodLiteral<TypeName>;
    }>[k_1]; } : never)[];
}>>;
type IsArrayRelation<E extends object, R extends keyof RelationProperty<E>> = RelationProperty<E>[R]['isArray'];
type IsNullableRelation<E extends object, R extends keyof RelationProperty<E>> = RelationProperty<E>[R]['nullable'];
type EntityParamForRel<E extends object, R extends keyof RelationProperty<E>, IdKey extends string> = EntityParam<RelationProperty<E>[R]['entityClass'], IdKey>;
type RelPrimaryColumnType<IdKey> = IdKey extends TypeForId ? IdKey : TypeField.string;
type ZodResultDataArray<E extends object, R extends keyof RelationProperty<E>, IdKey extends string> = ReturnType<typeof getZodResultDataArray<EntityParamForRel<E, R, IdKey>['typeName'], RelPrimaryColumnType<EntityParamForRel<E, R, IdKey>['primaryColumnType']>>>;
type ZodResultData<E extends object, R extends keyof RelationProperty<E>, IdKey extends string, IsPatch extends boolean> = ReturnType<typeof getZodResultData<EntityParamForRel<E, R, IdKey>['typeName'], RelPrimaryColumnType<EntityParamForRel<E, R, IdKey>['primaryColumnType']>, IsNullableRelation<E, R>, IsPatch>>;
type ZodData<E extends object, R extends keyof RelationProperty<E>, IdKey extends string, IsPatch extends boolean, IsArray extends boolean> = IsArray extends true ? ZodResultDataArray<E, R, IdKey> : ZodResultData<E, R, IdKey, IsPatch>;
export type ZodRelationShape<E extends object, IdKey extends string, IsPatch extends true | false = false> = {
    [K in keyof RelationProperty<E>]: ZodData<E, K, IdKey, IsPatch, IsArrayRelation<E, K>>;
};
export declare function zodRelationships<E extends object, IdKey extends string, IsPatch extends true | false = false>(entityParamMapService: EntityParamMapService<E, IdKey>, isPatch: IsPatch): z.ZodEffects<z.ZodObject<ZodRelationShape<E, IdKey, IsPatch>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ZodRelationShape<E, IdKey, IsPatch>>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ZodRelationShape<E, IdKey, IsPatch>>, any>[k]; } : never, z.baseObjectInputType<ZodRelationShape<E, IdKey, IsPatch>> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<ZodRelationShape<E, IdKey, IsPatch>>[k_1]; } : never>, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ZodRelationShape<E, IdKey, IsPatch>>, any> extends infer T_2 ? { [k in keyof T_2]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<ZodRelationShape<E, IdKey, IsPatch>>, any>[k]; } : never, z.baseObjectInputType<ZodRelationShape<E, IdKey, IsPatch>> extends infer T_3 ? { [k_1 in keyof T_3]: z.baseObjectInputType<ZodRelationShape<E, IdKey, IsPatch>>[k_1]; } : never>;
export type ZodRelationships<E extends object, IdKey extends string, S extends true | false = false> = ReturnType<typeof zodRelationships<E, IdKey, S>>;
export type Relationships<E extends object, IdKey extends string, S extends true | false = false> = z.infer<ZodRelationships<E, IdKey, S>>;
export {};
