import { EntityClass, AnyEntity } from '@klerick/json-api-nestjs-shared';
import { MethodName } from '../types';
import { Type } from '@nestjs/common/interfaces';
export declare const nameIt: (name: string, cls: new (...rest: unknown[]) => Record<never, unknown>) => {
    new (...arg: unknown[]): {};
};
export declare function getProviderName<Entity extends object>(entity: EntityClass<Entity>, name: string): string;
export declare function excludeMethod(names: Array<Partial<MethodName>>): Array<MethodName>;
export declare function entityForClass<T = any>(type: Type<T>): EntityClass<AnyEntity>;
